<template>
  <v-row>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Code" rules="required|max:255" v-model="unit.code">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom" density="compact"
          data-cy="UnitFormCodeInput" :error-messages="errors" class="required" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Name" rules="required|max:255" v-model="unit.name">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Dénomination" density="compact"
          data-cy="UnitFormNameInput" :error-messages="errors" class="required" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Address 1" rules="max:255" v-model="unit.address1">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Adresse 1" density="compact"
          data-cy="UnitFormAddress1Input" :error-messages="errors" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Address 2" rules="max:255" v-model="unit.address2">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Adresse 2" density="compact"
          data-cy="UnitFormAddress2Input" :error-messages="errors" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Address 3" rules="max:255" v-model="unit.address3">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Adresse 3" density="compact"
          data-cy="UnitFormAddress3Input" :error-messages="errors" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="PhoneNumber" rules="max:255" v-model="unit.phoneNumber">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Numéro de téléphone" density="compact"
          data-cy="UnitFormPhoneInput" :error-messages="errors" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Email" rules="max:255|email" v-model="unit.email">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Email" density="compact"
          data-cy="UnitFormEmailInput" :error-messages="errors" variant="outlined" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="8">
      <Field #default="{ errors, field, value }" name="Airports" rules="required" v-model="unit.airports">
        <v-autocomplete @update:model-value="field.onChange" :model-value="value" clear-on-select label="Aéroports" density="compact"
          :item-title="(airport: Airport) => `${airport.oaci}${airport.name ? ' - ' + airport.name : ''}`"
          data-cy="UnitFormAirportsInput" :error-messages="errors" :items="airports" multiple chips closable-chips
          variant="outlined" return-object class="required" color="primary">
          <template #chip="{ props, item }">
            <v-chip v-bind="props" :text="item.raw.name" />
          </template>
        </v-autocomplete>
      </Field>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">

import { Unit } from "~/dto/unit.dto";
import { Airport } from "~/dto/airport.dto";

defineProps<{ unit: Unit }>();

const store = useStore();

const airports: Ref<Airport[]> = computed(() => {
  return store.airportsEnabled;
});

</script>
